<!-----------------------------------------------------------------------
Author 	 :	Luis Majano
Date     :	September 25, 2005
Description :
	General handler for my hello application. Please remember to alter
	your extends base component using the Coldfusion Mapping.

	example:
		Mapping: fwsample
		Argument Type: fwsample.system.eventhandler
Modification History:
Sep/25/2005 - Luis Majano
	-Created the template.
----------------------------------------------------------------------->
<cfcomponent name="ehFlex" extends="coldbox.system.eventhandler">

	<!--- ************************************************************* --->

	<cffunction name="nothing" access="public" output="false" returntype="string">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfscript>
		
		if( event.isProxyRequest() ){
			return "Please call a valid event.";
		}
		
		event.setValue("data","yeaaa it works");
		event.setView("tester",true);
		
		</cfscript>
	</cffunction>
	
	<!--- ************************************************************* --->
	
	<cffunction name="getIntroArrays" access="public" output="false" returntype="Array">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfscript>
		//Just return an array
		var myArray = ArrayNew(1);
		
		myArray[1] = "Hola";
		myArray[2] = "Hello";
		myArray[3] = "Bom Dia";
		myArray[4] = "Ciao";
		myArray[5] = getMyPlugin("date").getToday();
		
		//Log my call
		getPlugin("logger").logEntry("information","My intro arrays called from flex.");
				
		return myArray;
		</cfscript>
	</cffunction>
	
	<!--- ************************************************************* --->

	<cffunction name="getIntroStructure" access="public" output="false" returntype="any">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfscript>
		var introStruct = structnew();
		
		introStruct.english = "Hello";
		introStruct.spanish = "Hola";
		introStruct.italian = "Ciao";
		
		getPlugin("logger").logEntry("information","My intro structures called from flex.");
		
		return introStruct;
		</cfscript>
	</cffunction>

	<!--- ************************************************************* --->
		
	<cffunction name="getCacheItemTypes" access="public" output="false" returntype="any">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfset var itemTypes = structnew()>
		
		<cfset itemTypes = getColdBoxOCM().getItemTypes()>
		
		<cfreturn itemTypes>
	</cffunction>

	<!--- ************************************************************* --->
	
	<cffunction name="readLog" access="public" output="false" returntype="string">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfset var LogFileContents = "">
		
		<cflog file="flextester" text="#getPlugin("logger").getLogFullPath()#">
		<cfset LogFileContents = getPlugin("Utilities").readFile(getPlugin("logger").getlogFullPath())>
			
		<cfreturn LogFileContents>
	</cffunction>

	<!--- ************************************************************* --->
	
	
	
</cfcomponent>