<cfcomponent name="ehGeneral" extends="coldbox.system.eventhandler">

	<!--- ************************************************************* --->
	<cffunction name="dspHome" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfscript>
		var rc = Event.getCollection();
		rc.xehGetNews = "ehGeneral.doGetNews";
		rc.xehGetNewsClient = "ehGeneral.doGetNewsClientVersion";
		rc.xehDeleteNews = "ehGeneral.doClearClientStorageNews";
		// Set the View To Display, after Logic
		Event.setView("vwHome");
		</cfscript>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doGetNews" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfscript>
		var wsObj = getPlugin("webservices").getWsobj("newsfeed");
		var rc = Event.getCollection();
		rc.xehGetNews = "ehGeneral.doGetNews";
		rc.xehGetNewsClient = "ehGeneral.doGetNewsClientVersion";
		rc.xehDeleteNews = "ehGeneral.doClearClientStorageNews";
		try{
			//call model
			rc.newsfeed = wsObj.GetUpdateInfo("1.1.0","1.1.0");
		}
		catch(Any e){
			//Log Error using logger plugin
			getPlugin("logger").logError("Error retrieveing news",e);
			//Set message
			getPlugin("messagebox").setMessage("error","Error retrieveing news feed. <br><br>Diagnostics:<br>#e.message#<br>#e.detail#");
			//Set view and exit
			Event.setView("vwHome");
			return;
		}
		//Set a Messagebox for display purposes.
		getPlugin("messagebox").setMessage("info","News retrieved and placed in request collection.");
		//set the view
		Event.setView("vwHome");
		</cfscript>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doGetNewsClientVersion" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfscript>
		//Model Call
		var wsObj = getPlugin("webservices").getWsobj("newsfeed");
		var newsfeed = wsObj.GetUpdateInfo("1.1.0","1.1.0");
		//Using clientStorage plugin to save variables permanently
		getPlugin("clientStorage").setVar("newsfeed", newsfeed);
		//Set the Messagebox
		getPlugin("messagebox").setMessage("info","News retrieved using the clientstorage plugin.");
		//Relocate to next Event, we can do this, since the data is in a storage.
		setNextEvent("ehGeneral.dspHome");
		</cfscript>
	</cffunction>
	<!--- ************************************************************* --->

	<!--- ************************************************************* --->
	<cffunction name="doClearClientStorageNews" access="public" returntype="void" output="false">
		<cfargument name="Event" type="coldbox.system.beans.requestContext">
		<cfscript>
		//Clear ClientStorage News
		getPlugin("clientStorage").deleteVar("newsfeed");
		//Set the Messagebox
		getPlugin("messagebox").setMessage("info","News deleted from client storage.");
		//Relocate to next Event, we can do this, since the data is in a storage.
		setNextEvent("ehGeneral.dspHome");
		</cfscript>
	</cffunction>
	<!--- ************************************************************* --->
	
</cfcomponent>